// HScr2Clpbrd_DLL.cpp : Defines the entry point for the DLL application.
//
// Yinghsuan Huang 04/14/2002
//
// Hook system Keyboard Event,WH_KEYBOARD
// Application will Un/Install this Hook DLL
// If user click PrintScreen, Post a user-defined msg to apps
//
// Reference:
// [1]: "Message Management", Joseph M. Newcomer, 05/17/2000, http://www.codeproject.com 
// [2]: "Hooks and DLLs", Joseph M. Newcomer, 04/01/2001, http://www.codeproject.com 
// [3]: "API hooking revealed", Ivo Ivanov, 04/06/2002, http://www.codeproject.com
// [4]: "Win32 Hooks", Kyle Marsh, 07/29/1993, MSDN
//
#include "stdafx.h"

#pragma data_seg(".HUANGDATA")
HWND hWndReceiver = NULL;
#pragma data_seg()
#pragma comment(linker, "/section:.HUANGDATA,rws")

//define Click_PrintScreen window message
static UINT UWM_ClickPrnScrn; 
HHOOK hookKeyBoard;
HINSTANCE hInst;

static LRESULT CALLBACK KeyboardHook(UINT nCode, WPARAM wParam, LPARAM lParam);
__declspec(dllexport) BOOL InstallKBHook(HWND hWnd);
__declspec(dllexport) BOOL UnInstallKBHook(HWND hWnd);


BOOL APIENTRY DllMain( HINSTANCE  hInstance,DWORD  ul_reason_for_call,LPVOID lpReserved)
{
	switch(ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		UWM_ClickPrnScrn = ::RegisterWindowMessage("UWM_ClickPrintScreen_B2ABC742-0A63-49c3-9ACB-CF0068027A66");
		hInst = hInstance;
		return TRUE;
	case DLL_PROCESS_DETACH:
		return TRUE;
	}
    return TRUE;
}

//-----------------------------------------------------------------------------
// if user click PrintScreen, PostMsg to Apps
static LRESULT CALLBACK KeyboardHook(UINT nCode, WPARAM wParam, LPARAM lParam)
{
	if( (nCode >=0) && (nCode == HC_ACTION) && (wParam == VK_SNAPSHOT))	
		::PostMessage(hWndReceiver,UWM_ClickPrnScrn,0,0);

	return CallNextHookEx(hookKeyBoard,nCode,wParam,lParam);
}

//----------------------------------------------------------------------------
// Main application will call this method to Hook keyboard
// Must "EXPORT"
__declspec(dllexport) BOOL InstallKBHook(HWND hWnd)
{
	if( hWndReceiver != NULL) 
		return FALSE; //reHook

	hookKeyBoard = SetWindowsHookEx(WH_KEYBOARD,(HOOKPROC)KeyboardHook,	hInst,0);
	if(hookKeyBoard != NULL)
	{ 
		hWndReceiver  = hWnd;
		return TRUE;
	}
	return FALSE;
} // InstallKBHook


//----------------------------------------------------------------------------
// Main application will call this method to UnHook keyboard
// Must "EXPORT"
__declspec(dllexport) BOOL UnInstallKBHook(HWND hWnd)
{
	if((hWnd == NULL) || (hWnd != hWndReceiver))
		return FALSE;

    BOOL bUnHook = UnhookWindowsHookEx(hookKeyBoard);
	if(bUnHook)
		 hWndReceiver = NULL;

    return bUnHook;
} // UnInstallKBHook
